
// The package containing our stubs.
import HelloApp1.*;

// HelloServer will use the naming service.
import org.omg.CosNaming.*;

// The package containing special exceptions thrown by the name service.
import org.omg.CosNaming.NamingContextPackage.*;

// All CORBA applications need these classes.
import org.omg.CORBA.*;
import java.util.*;


public class HelloServer
{
  public static void main(String args[])
  {
    try{

 	Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass","com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass","com.ooc.CORBA.ORBSingleton");
        ORB orb = ORB.init(args, props);
        System.out.print("\n" + "Initialized ORB");

      // Create the servant and register it with the ORB

	BOA boa=((com.ooc.CORBA.ORB)orb).BOA_init(args,props);
        HelloImpl helloRef = new HelloImpl();
        orb.connect(helloRef);

	System.out.print("... Initialized the BOA");
       /* Get the root naming context */
        org.omg.CORBA.Object objRef = orb.string_to_object("iioploc://128.230.8.140:5556/NameService");
        //orb.resolve_initial_references("NameService");
        NamingContext ncRef = NamingContextHelper.narrow(objRef);
        System.out.print("... Resolved the reference to the NameService");

        /* Bind the Object Reference in Naming */
        NameComponent nc = new NameComponent("HelloServer","");
        NameComponent path[] = {nc};
        ncRef.rebind(path, helloRef);

        System.out.println("Successfully bound Ref's to NameService");

        boa.impl_is_ready(null);



    } catch(Exception e) {
        System.err.println("ERROR: " + e);
        e.printStackTrace(System.out);
      }
  }
}



class HelloImpl extends _HelloImplBase
{

  public String sayHello(CallBackHello obj)
  {
	System.out.println("In server.");
    return obj.hello();

  }
}
